// SPDX-License-Identifier: UNLICENSED
pragma solidity ^0.8.13;

import {Script, console} from "forge-std/Script.sol";
import {Setup} from "src/Setup.sol";
import {CryptoFlags} from "src/CryptoFlags.sol";

contract SolveScript is Script {
    Setup setup;
    CryptoFlags cryptoFlags;
    function setUp() public {
        address addr = vm.envOr("SETUP", address(0));
        if (addr != address(0))
            setup = Setup(addr);
        else
            setup = new Setup();
        cryptoFlags = setup.cryptoFlags();
    }

    function run() public virtual {
        uint256 id = 133337;
        vm.startBroadcast();
        cryptoFlags.claimFlag(id);
        cryptoFlags.setFlagName(id, "leeeeeet");
        vm.stopBroadcast();

        console.log("Flag name for", id, "=", cryptoFlags.FlagNames(id));
        require(setup.isSolved(), "did not solve :'(");
    }
}
