#!/bin/sh
set -eu

if ! command -v jq &> /dev/null
then
    echo "'jq' could not be found"
    exit 1
fi

if ! command -v forge &> /dev/null
then
    echo "'forge' could not be found, install foundry"
    exit 1
fi

if [ "$#" -ne 1 ]; then
    echo "Need exactly one argument, path to player_info.json"
    exit 1
fi

PLAYER_INFO_PATH=$1
if [ ! -f "${PLAYER_INFO_PATH}" ] ; then
  echo "${PLAYER_INFO_PATH} file does not exist"
  exit 1
fi

KEY=$(jq -r '.private_key' < "${PLAYER_INFO_PATH}")
SENDER=$(jq -r '.address' < "${PLAYER_INFO_PATH}")
SETUP=$(jq -r '.setup' < "${PLAYER_INFO_PATH}")

SETUP="${SETUP}" forge script script/Solve.s.sol:SolveScript --private-key "${KEY}" --sender "${SENDER}" --broadcast --rpc-url http://10.244.0.1:8545
